package org.openmuc.jdlms.internal;

import java.text.MessageFormat;

public enum ContextId {
    LOGICAL_NAME_REFERENCING_NO_CIPHERING(1),
    SHORT_NAME_REFERENCING_NO_CIPHERING(2),
    LOGICAL_NAME_REFERENCING_WITH_CIPHERING(3),
    SHORT_NAME_REFERENCING_WITH_CIPHERING(4);

    private static final ContextId[] VALUES = values();
    private int code;

    public static ContextId contextIdFor(int code) {
        for (ContextId value : VALUES) {
            if (value.code == code) {
                return value;
            }
        }
        throw new IllegalArgumentException(MessageFormat.format("Unknown code {0}.", code));
    }

    private ContextId(int code) {
        this.code = code;
    }

    public int getCode() {
        return code;
    }

    public boolean isCiphered() {
        return this == LOGICAL_NAME_REFERENCING_WITH_CIPHERING
                || this == ContextId.SHORT_NAME_REFERENCING_WITH_CIPHERING;
    }
}
