/*
 * Copyright 2012-17 Fraunhofer ISE
 *
 * This file is part of jDLMS. For more information visit http://www.openmuc.org
 *
 * jDLMS is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * jDLMS is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with jDLMS. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 */
package org.openmuc.jdlms.internal.sessionlayer.hdlc;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class HdlcParameterNegotiationTest {

    @Test
    public void tesEncodeDecodetSymmetry() throws Exception {
        final int receiveInformationLength = HdlcParameterNegotiation.MIN_INFORMATION_LENGTH + 2;
        final int receiveWindowSize = HdlcParameterNegotiation.MIN_WINDOW_SIZE + 3;
        HdlcParameterNegotiation parameterNegotiation = new HdlcParameterNegotiation(receiveInformationLength,
                receiveWindowSize);

        byte[] encodedParameterNegotiation = parameterNegotiation.encode();

        HdlcParameterNegotiation parameterNegotiation2 = HdlcParameterNegotiation.decode(encodedParameterNegotiation);

        assertEquals(receiveInformationLength, parameterNegotiation2.receiveInformationLength());
        assertEquals(receiveWindowSize, parameterNegotiation2.receiveWindowSize());
    }

    @Test
    public void encode() throws Exception {
        HdlcParameterNegotiation dNegotiation = new HdlcParameterNegotiation(
                HdlcParameterNegotiation.MIN_INFORMATION_LENGTH, HdlcParameterNegotiation.MIN_WINDOW_SIZE);

        assertTrue("didn't encode correctly", dNegotiation.encode() == null);
    }
}
